<?php
/*
Plugin Name: Contenshik
Plugin URI: http://www.contenshik.com/wordpress_plugin.html
Description: Import blogs content from various bloghosting allover Internet.
Author: Alexey Dev
Version: 1.0b
*/

add_action('admin_menu', 'contenshik_config');


function contenshik_config() {
	add_options_page('Contenshik Config', 'Contenshik.com', 8, __FILE__, 'contenshik_page_config');
	add_submenu_page('post-new.php','Contenshik.com Get Posts','Contenshik.com', 8, __file__, 'contenshik_page_write');
}


function contenshik_page_write() {

	echo '<div class="wrap"><h2>Getting Pages from Contenshik.com</h2>';
	echo '
<br>
<form name="form1" method="post" action="'. str_replace( '%7E', '~', $_SERVER['REQUEST_URI']) .'" enctype="multipart/form-data">
<input type="submit" name="load" value="Load From File" /> or <input type="submit" name="fetch" value="Get From Contenshik.com" /> <br /><br />
';


	if ( isset($_POST['load']) ) {
echo '
<table class="form-table">
<tr valign="top">
<th scope="row"><label for="f1">Select .DAT File:</label></th>
<td><input name="filez" id=f1 type="file" class="code" size="40" /><br/>select file, that you downloaded from contenshik.com (results data file)</td>
</tr>

<tr valign="top">
<th scope="row"><label for="f2">Post In Draft:</label></th>
<td><input name="draft" id=f2 type="checkbox" value="1" /></td>
</tr>

</table>

<p class="submit">
<input type="submit" name="do" value="Get Now" />
</form>
</p>

';
	}

	if ( isset($_POST['fetch']) ) {
		$balance = contenshik_request_balance();
		$testfilter = contenshik_request_testfilter();
		echo '
<table class="form-table">
<tr valign="top">
<th scope="row"><label for="upload_path">Your balance (wmr):</label></th>
<td><b>'.$balance.'</b></td>
</tr>

<tr valign="top">
<th scope="row"><label for="upload_path">Filter result (posts count):</label></th>
<td><b>'.$testfilter.'</b></td>
</tr>

<tr valign="top">
<th scope="row"><label for="f2">Post In Draft:</label></th>
<td><input name="draft" id=f2 type="checkbox" value="1" /></td>
</tr>

</table>

<p class="submit">
<input type="submit" name="do" value="Get Now!" />
</form>
</p>
		';
	}

	
	
	if ( isset($_POST['do']) ) {
		if ( isset($_POST['file']) ) {
			if ( is_uploaded_file($_FILES['file']['tmp_name']) ) {
				$data = file($_FILES['file']['tmp_name']);
				$res = true;
			}
		}
		else {
			$res = contenshik_request_filterandexport($data);
			if ( $res ) $data = @gzuncompress($data);
		}
		
		
		if ( $res == true ) {
			$array = unserialize($data);
			$charset = get_option('blog_charset');
			$status = ( $_POST['draft'] ) ? 'draft' : 'publish';
			foreach ( $array AS $r ) {
				$id = $r[0];
				$time = $r[1];
				$title = trim($r[2]);
				$text = trim($r[3]);
				$textmore = trim($r[4]);
				if ( $charset != 'windows-1251' ) {
					$title = iconv('windows-1251', $charset, $title);
					$text = iconv('windows-1251', $charset, $text);
					$textmore = iconv('windows-1251', $charset, $textmore);
				}
				$date = date('Y-m-d H:i:s', $time);
				if ( $textmore ) $text .= "<!--more-->".$textmore;
				$post = array(
					'post_title' => $title,
					'post_content' => $text,
					'post_date' => $date,
					'post_status' => $status,
				);
				wp_insert_post( $post );
			}
			
			echo '<div class="updated"><p><strong>Import Successful!</strong></p></div>';
		}
		else {
			echo '<div class="updated"><p><strong>ERROR</strong></p></div>';
		}
		
		
	}
	
	
  echo '</div>';

}



function contenshik_request_filterandexport(&$data) {
	$api =  get_option( 'contenshik_api_key' );
	$filter =  get_option( 'contenshik_filter' );
	$cutter =  get_option( 'contenshik_cutter' );
	$tagclose =  get_option( 'contenshik_tagclose' );
	$title =  get_option( 'contenshik_title' );
	$syn =  get_option( 'contenshik_syn' );
	
	$mods = '';
	if ( $cutter ) $mods .= 'mod_cutter,';
	if ( $tagclose ) $mods .= 'mod_tagclose,';
	if ( $title ) $mods .= 'mod_title,';
	if ( $syn ) $mods .= 'mod_syn,';
	$mods = substr($mods, 0, -1);
	
	$comments = getenv('HTTP_HOST');
	
	$path = "/api/$api/filterandexport/$filter/$comments/ser1/$mods/";
	$data = contenshik_request_http('', $path);
	
	
	if ( substr($data, 0, 3) == "+OK" ) {
		$data = substr($data,4);
		return true;
	}
	elseif ( substr($data, 0, 4) == "-ERR" ) {
		$err = substr($data, 5);
		$data = "Error: $err";
		return false;
	}
	else {
		$dat = "Server not ready.";
		return false;
	}
}

function contenshik_request_testfilter() {
	$api =  get_option( 'contenshik_api_key' );
	$filter =  get_option( 'contenshik_filter' );
	$path = "/api/$api/testfilter/$filter/";
	$data = contenshik_request_http('', $path);
	
	
	if ( substr($data, 0, 3) == "+OK" ) {
		$data = substr($data,4);
		return $data;
	}
	elseif ( substr($data, 0, 4) == "-ERR" ) {
		$err = substr($data, 5);
		return "Error: $err";
	}
	else {
		return "Server not ready.";
	}
}

function contenshik_request_balance() {
	$api =  get_option( 'contenshik_api_key' );
	$path = "/api/$api/balance/";
	$data = contenshik_request_http('', $path);
	
	
	if ( substr($data, 0, 3) == "+OK" ) {
		$data = substr($data,4);
		return $data;
	}
	elseif ( substr($data, 0, 4) == "-ERR" ) {
		$err = substr($data, 5);
		return "Error: $err";
	}
	else {
		return "Server not ready.";
	}
}


function contenshik_request_http($request, $path) {
	global $wp_version;
	
	$host = get_option( 'contenshik_host' );
	
	$head  = "GET $path HTTP/1.0\r\n";
	$head .= "Host: $host\r\n";
	$head .= "Content-Type: text/plain; charset=" . get_option('blog_charset') . "\r\n";
	//$head .= "Content-Length: " . strlen($request) . "\r\n";
	$head .= "User-Agent: WordPress/$wp_version (ContenshikPlugin/1.0)\r\n";
	$head .= "\r\n";
	//$head .= $request;
	
	$response = '';
	if( false != ( $fs = @fsockopen($host, 80, $errno, $errstr, 10) ) ) {
		fwrite($fs, $head);

		while ( !feof($fs) )
			$response .= fgets($fs, 1160); // One TCP-IP packet
		fclose($fs);
		$response = explode("\r\n\r\n", $response, 2);
	}
	if ( $errstr ) return "-ERR $errstr";
	return $response[1];
}



function contenshik_page_config() {

	if( $_POST[ 'Submit' ] ) {
		$api_key = trim($_POST[ 'contenshik_api_key' ]);
		$host = trim($_POST[ 'contenshik_host' ]);
		$filter = trim($_POST[ 'contenshik_filter' ]);
		$cutter = trim($_POST[ 'contenshik_cutter' ]);
		$tags = trim($_POST[ 'contenshik_tags' ]);
		$syn = trim($_POST[ 'contenshik_syn' ]);
		
		add_option('contenshik_api_key', $api_key, 'api key value', 'no');
		update_option( 'contenshik_api_key', $api_key );
		
		add_option('contenshik_host', $host, 'srv host', 'no');
		update_option( 'contenshik_host', $host );
		
		add_option('contenshik_filter', $filter, 'filter id', 'no');
		update_option( 'contenshik_filter', $filter );
		
		add_option('contenshik_filter', $filter, 'filter id', 'no');
		update_option( 'contenshik_filter', $filter );
		
		add_option('contenshik_cutter', $cutter, 'use cutter', 'no');
		update_option( 'contenshik_cutter', $cutter );
		
		add_option('contenshik_tagclose', $tags, 'use tag close', 'no');
		update_option( 'contenshik_tagclose', $tags );
		
		add_option('contenshik_syn', $syn, 'use tag close', 'no');
		update_option( 'contenshik_syn', $syn );
		
		echo '<div class="updated"><p><strong>Saved!</strong></p></div>';
	}
	
	$api_key = get_option( 'contenshik_api_key' );
	$host = get_option( 'contenshik_host' );
	$filter = get_option( 'contenshik_filter' );

	$cutter = ( get_option( 'contenshik_cutter' ) ) ? 'checked' : '';
	$tags = ( get_option( 'contenshik_tagclose' ) ) ? 'checked' : '';
	$syn = ( get_option( 'contenshik_syn' ) ) ? 'checked' : '';

  echo '<div class="wrap"><h2>Configure using service Contenshik.com</h2>';
  echo '
<form name="form1" method="post" action="'. str_replace( '%7E', '~', $_SERVER['REQUEST_URI']) .'">

<table class="form-table">

<tr valign="top">
<th scope="row"><label for="f1">API key</label></th>
<td><input name="contenshik_api_key" type="text" id="f1" class="code" value="'.$api_key.'" size="40" />
<br />
Your personal API Key value, get it from Contenshik.com Account.
</td>
</tr>


<tr valign="top">
<th scope="row"><label for="f2">Contenshik Host</label></th>
<td><input name="contenshik_host" type="text" id="f2" class="code" value="'.$host.'" size="40" />
<br />
Default is <i>api.contenshik.com</i>
</td>
</tr>


<tr valign="top">
<th scope="row"><label for="f3">Filter ID</label></th>
<td><input name="contenshik_filter" type="text" id="f3" class="code" value="'.$filter.'" size="40" />
<br />
Enter Filter Id, that you create on Search Page at Contenshik.com
</td>
</tr>

<tr valign="top">
<th scope="row"><label for="f4">Use tag More</label></th>
<td><input name="contenshik_cutter" type="checkbox" id="f4" class="code" value="1" "'.$cutter.'" size="40" />
<br />
Content will be automatically cut on Preview and Read More.
</td>
</tr>

<tr valign="top">
<th scope="row"><label for="f5">Close All Tags</label></th>
<td><input name="contenshik_tags" type="checkbox" id="f5" class="code" value="1" "'.$tags.'" size="40" />
<br />
Service will automatically close all non-closed tags in post.
</td>
</tr>

<tr valign="top">
<th scope="row"><label for="f6">Synonimaser</label></th>
<td><input name="contenshik_syn" type="checkbox" id="f6" class="code" value="1" "'.$syn.'" size="40" />
<br />
Each 4th word will be synonimased.
</td>
</tr>



</table>

<p class="submit">
<input type="submit" name="Submit" value="Save" />
</form>
</p>

';
  echo '</div>';

}

?>